hdu-1548 A strange lift

Posted euzmin

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了hdu-1548 A strange lift相关的知识,希望对你有一定的参考价值。

There is a strange lift.The lift can stop can at every floor as you want, and there is a number Ki(0 <= Ki <= N) on every floor.The lift have just two buttons: up and down.When you at floor i,if you press the button "UP" , you will go up Ki floor,i.e,you will go to the i+Ki th floor,as the same, if you press the button "DOWN" , you will go down Ki floor,i.e,you will go to the i-Ki th floor. Of course, the lift can‘t go up high than N,and can‘t go down lower than 1. For example, there is a buliding with 5 floors, and k1 = 3, k2 = 3,k3 = 1,k4 = 2, k5 = 5.Begining from the 1 st floor,you can press the button "UP", and you‘ll go up to the 4 th floor,and if you press the button "DOWN", the lift can‘t do it, because it can‘t go down to the -2 th floor,as you know ,the -2 th floor isn‘t exist.
Here comes the problem: when you are on floor A,and you want to go to floor B,how many times at least he has to press the button "UP" or "DOWN"?
InputThe input consists of several test cases.,Each test case contains two lines.
The first line contains three integers N ,A,B( 1 <= N,A,B <= 200) which describe above,The second line consist N integers k1,k2,....kn.
A single 0 indicate the end of the input.OutputFor each case of the input output a interger, the least times you have to press the button when you on floor A,and you want to go to floor B.If you can‘t reach floor B,printf "-1".Sample Input

5 1 5
3 3 1 2 5
0

Sample Output

3

这题题意很好理解,单纯的bfs。
但是在这题中学到了一个技巧,存代码记录。
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <queue>
using namespace std;
const int M = 4222;
int btn[M];
int vis[M];
queue<int> q;
int main(){
	int n,a,b,cnt=0;
	while(cin>>n){
		queue<int> q;
		int f=0;cnt=0;
		memset(btn,0,sizeof(btn));
		memset(vis,0,sizeof(btn));
		if(n==0) break;
		cin>>a>>b;
		for(int i=1;i<=n;i++){
			cin>>btn[i];
		}
		q.push(a);
		vis[a]=1;
		while(!q.empty()){
				int u=q.front(); q.pop();
			//	cout<<u<<endl;
				int v=u+btn[u]; if(v<=n&&!vis[v]) {q.push(v);vis[v]=vis[u]+1; } 
				//用vis数组记录是否到达过的同时,记录它是第几步 
				int w=u-btn[u]; if(w>=1&&!vis[w]) {q.push(w);vis[w]=vis[u]+1; }
			if(v==b||w==b) break;
		}
		cout<<vis[b]-1<<endl;
	}
	return 0;
}

  

以上是关于hdu-1548 A strange lift的主要内容,如果未能解决你的问题,请参考以下文章

HDU 1548 A strange lift (暴力搜索)

HDU 1548 A strange lift

HDU 1548 A strange lift

hdu1548 A strange lift(bfs)

hdu 1548 A strange lift (dijkstra)

HDU 1548 A strange lift(dij+邻接矩阵)